import com.visibleworkings.trace.TraceLogList;
import com.visibleworkings.trace.TraceParsedMessage;
import java.io.File;
import java.util.List;
import java.util.Iterator;

public class DumpExampleCheck extends LogChecker {

    public static void main(String[] args) {
        pushContext("... checking DumpExample results.");
        File cwd = new File(System.getProperty("user.dir"));

        TraceLogList list = openLogs(cwd, "TraceDump");
        assertNumLogs(list, 1);

        List msgs = logMessages(list);
        assertNumMessages(msgs, 8);

        assertValues((TraceParsedMessage) msgs.get(0),
            "TraceBuffer.dump", "TraceBuffer.java", null, "ERR",
            "trace", "======================= BEGIN INTERNAL TRACE BUFFER DUMP =======================");
        assertValues((TraceParsedMessage) msgs.get(1),
            null, "TraceBuffer.java", null, "WLD",
            "trace", "Transient buffer begins.");
        assertValues((TraceParsedMessage) msgs.get(2),
            "TraceController.start", "TraceController.java", null, "USE",
            "trace", "Tracing system being started.");
        assertValues((TraceParsedMessage) msgs.get(3),
            "TraceLog.beginLogging", "TraceLog.java", null, "USE",
            "trace", null); // message contains absolute pathname.
        assertValues((TraceParsedMessage) msgs.get(4),
            "DumpExample.main", "DumpExample.java", "20", "USE",
            "DumpExample", "This USAGE message will appear in the buffer. It will appear in the log once the buffer is dumped there.");
        assertValues((TraceParsedMessage) msgs.get(5),
            "DumpExample.main", "DumpExample.java", "27", "DBG",
            "DumpExample", "This DEBUG message will appear in the buffer. It will appear in the log once the buffer is dumped there.");
        assertValues((TraceParsedMessage) msgs.get(6),
            "TraceBuffer.dump", "TraceBuffer.java", null, "USE",
            "trace", "Dumping internal trace buffer.");
        assertValues((TraceParsedMessage) msgs.get(7),
            "TraceBuffer.dump", "TraceBuffer.java", null, "ERR",
            "trace", "======================= END INTERNAL TRACE BUFFER DUMP =======================");

        popContext();
        success();
    }

}
