import com.visibleworkings.trace.TraceLogList;
import com.visibleworkings.trace.TraceParsedMessage;
import java.io.File;
import java.util.List;
import java.util.Iterator;

public class SwitchCheck extends LogChecker {

    public static void main(String[] args) {
        pushContext("... checking Switch results.");
        File cwd = new File(System.getProperty("user.dir"));

        traceswitch(cwd);
        frobboz(cwd);

        popContext();
        success();
    }
        

    private static void traceswitch(File cwd) { 
        pushContext("... checking TraceSwitch logs.");
        TraceLogList list = openLogs(cwd, "TraceSwitch");
        assertNumLogs(list, 2);
        assertLogName(list, 0, "TraceSwitch.000.txt");
        assertLogName(list, 1, "TraceSwitch.txt");

        List msgs = logMessages(list);
        assertNumMessages(msgs, 3);

        assertValues((TraceParsedMessage) msgs.get(0),
            "Switch.main", "Switch.java", "17", "WLD",
            "Switch", "Subsystem starts. (step 1)");
        assertValues((TraceParsedMessage) msgs.get(1),
            null, null, null, "WLD",
            "trace", "This is a continuation of a previous log.");
        assertValues((TraceParsedMessage) msgs.get(2),
            "Switch.main", "Switch.java", "21", "WLD",
           "Switch", "This will appear in a new log file (step 3).");

        popContext();
    }

    private static void frobboz(File cwd) { 
        pushContext("... checking Frobboz logs");

        TraceLogList list = openLogs(cwd, "Trace.quux");
        assertNumLogs(list, 1);
        assertLogName(list, 0, "Trace.quux.frobboz---");

        List msgs = logMessages(list);
        assertNumMessages(msgs, 2);

        // First, a continuation message.
        assertValues((TraceParsedMessage) msgs.get(0),
            null, null, null, "WLD", "trace", null);

        assertValues((TraceParsedMessage) msgs.get(1),
            "Switch.main", "Switch.java", "28", "WLD",
            "Switch", "This will appear in the frobboz file. (step 5)");

        popContext();
    }

}
