import com.visibleworkings.trace.TraceLogList;
import com.visibleworkings.trace.TraceParsedMessage;
import java.io.File;
import java.util.List;
import java.util.Iterator;

public class TimestampCheck extends LogChecker {

    public static void main(String[] args) {
        pushContext("... checking Timestamp results.");
        File cwd = new File(System.getProperty("user.dir"));

        TraceLogList list = openLogs(cwd, "Tracelog");
        // The Basic test, which also uses "Tracelog", might have run
        // before this, so don't check the number of files.
        // assertNumLogs(list, 1);

        List msgs = logMessages(list);
        // And don't assert the number of messages.
        // assertNumMessages(msgs, 11);

        assertValues((TraceParsedMessage) msgs.get(0),
            "Timestamp.main", "Timestamp.java", "21", "WLD",
            "Timestamp", "Timestamp subsystem starts.");

        popContext();
        success();
    }

}
