import com.visibleworkings.trace.TraceLogList;
import com.visibleworkings.trace.TraceParsedMessage;
import java.io.File;
import java.util.List;
import java.util.Iterator;

public class TimingBufferCheck extends LogChecker {

    public static void main(String[] args) {
        pushContext("... checking TimingBuffer results.");
        File cwd = new File(System.getProperty("user.dir"));

        TraceLogList list = openLogs(cwd, "Tracelog");
        assertNumLogs(list, 1);

        List msgs = logMessages(list);
        assert(msgs.size() > 500, "Too few messages - trace buffer missing?");
        assert(msgs.size() < 510, "Too many messages - trace buffer is not 500?");

        assertValues((TraceParsedMessage) msgs.get(0),
            "TimingBuffer.main", "TimingBuffer.java", "27", "TIM",
            "TimingBuffer", "Starting message loop.");
        assertValues((TraceParsedMessage) msgs.get(1),
            "TimingBuffer.main", "TimingBuffer.java", "32", "TIM",
            "TimingBuffer", "Ending message loop.");

        // Check a buffer message
        assertValues((TraceParsedMessage) msgs.get(10),
            "TimingBuffer.main", "TimingBuffer.java", "30", "USE",
            "TimingBuffer", "By default, usage messages go only into the transient buffer.");

        assertValues((TraceParsedMessage) msgs.get(msgs.size()-2),
            "TimingBuffer.main", "TimingBuffer.java", "41", "TIM",
            "TimingBuffer", "Starting concatenation message loop.");
        assertValues((TraceParsedMessage) msgs.get(msgs.size()-1),
            "TimingBuffer.main", "TimingBuffer.java", "46", "TIM",
            "TimingBuffer", "Ending message loop.");

        popContext();
        success();
    }

}
