import com.visibleworkings.trace.TraceLogList;
import com.visibleworkings.trace.TraceParsedMessage;
import java.io.File;
import java.util.List;
import java.util.Iterator;

public class WriteCheck extends LogChecker {

    public static void main(String[] args) {
        pushContext("... checking Write results.");
        File cwd = new File(System.getProperty("user.dir"));

        TraceLogList list = openLogs(cwd, "TraceWrite");
        assertNumLogs(list, 1);

        List msgs = logMessages(list);
        assert(msgs.size() >= 5, "Not enough messages in log.");

        // The first message is not the one printed before writing started.
        assertValues((TraceParsedMessage) msgs.get(0),
            "Write.main", "Write.java", "36", "ERR",
            "Write", "This message will appear in both the log and the buffer.");

        // The last message is not the one printed after writing stopped.
        assertValues((TraceParsedMessage) msgs.get(msgs.size()-1),
            null, null, null, null,
            "trace", "======================= END INTERNAL TRACE BUFFER DUMP =======================");

        popContext();
        success();
    }

}
